(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: TPADPROC.PAS                                                   *)
(*  Obsah: procedury a funkce k Turbopadu                                  *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava:                                                       *)
(*  Pro kompilaci: TURBOPAD.PAS                                            *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

function BtS(vstup:boolean):string;{Boolean to String}
Begin
if vstup then bts:='Ano' else bts:='Ne';
End;{bts}

function StB(vstup:string):boolean;{String to Boolean, neplette si s... vsak vite s cim}
Begin
if stringup(vstup)='NE' then stb:=ne else stb:=ano;{takze to skousne treba i 'Jo' a podobne}
End;{stb}

procedure SeridKurzor;
Begin
rozmerykurzoru(textwidth('A'),textheight256('A'));
End;{SeridKurzor}

function NaKonci:boolean;{false = kurzor je prave uprostred textu, rezim vkladani}
Begin
nakonci:=index=byte(pret[0]);
End;{nakonci}

procedure ResetText;
Begin
pret:=''; index:=0;
End;{resettext}

procedure ZapniPsani;
Begin
pisese:=ano; barvakurzoru(10);
End;{zapnipsani}

procedure VypniPsani;
Begin
pisese:=ne; barvakurzoru(15);
End;{vypnipsani}

procedure LoadSetup;{nacteni nastaveni}
var f:text; pomstr:string[3];
Begin
assign(f,'TURBOPAD.CFG');
reset(f);
if ioresult=0 then begin
                   readln(f);{v souboru jsou popisky, proto je potreba nektere radky vynechat}
                   readln(f);readln(f);readln(f);readln(f);
                   readln(f,jmenos);
                   readln(f);
                   readln(f,cislos);
                   readln(f);
                   readln(f);
                   readln(f,karta);
                   readln(f);
                   readln(f,rezim);
                   readln(f);
                   readln(f);
                   readln(f,pomstr); kresleniodruky:=stb(pomstr);
                   readln(f);
                   readln(f,delkacarky);
                   readln(f);
                   readln(f,meziradky);
                   readln(f);
                   readln(f,sirkatabulatoru);
                   readln(f);
                   readln(f,pfont);
                   readln(f);
                   readln(f,pvelikostpisma);
                   readln(f);
                   readln(f,barvapozadi);
                   readln(f);
                   readln(f,barvacary);
                   readln(f);
                   readln(f,barvatextu);
                   readln(f);
                   readln(f,pomstr); potvrzeniprisave:=stb(pomstr);
                   readln(f);
                   readln(f,pomstr); potvrzenipriload:=stb(pomstr);
                   readln(f);
                   readln(f,pomstr); hlasitchyby:=stb(pomstr);
                   readln(f);
                   readln(f,pomstr); autosaveb:=stb(pomstr);
                   readln(f);
                   readln(f,pomstr); autosaveb2:=stb(pomstr);
                   readln(f);
                   readln(f,ussx);
                   readln(f,ussy);
                   {readln(f);{radek s textem 'konec souboru'}
                   close(f);
                   if(ioresult<>0)and hlasitchyby then infokno(getmaxx shr 1,getmaxy shr 1,
                    'Problem pri nacitani nastaveni (asi nic vazneho).',ano);
                   end
              else begin
                   jmenos:='';
                   cislos:=0;
                   karta:=0; rezim:=gm640x480x16;{to snad zvladne kazdy monitor}
                   kresleniodruky:=ne;
                   delkacarky:=6;
                   meziradky:=3;
                   sirkatabulatoru:=6;
                   pfont:=0;
                   pvelikostpisma:=1;
                   barvapozadi:=0;
                   barvacary:=12;
                   barvatextu:=2;
                   potvrzeniprisave:=ne;
                   potvrzenipriload:=ne;
                   hlasitchyby:=ano;
                   autosaveb:=ano;
                   autosaveb2:=ano;
                   ussx:=0; ussy:=0;
                   end;
if (global_grafrezim shr 8)>0 then begin{ta podminka je tu proto, abych mohl nacitat nastaveni jeste pred spustenim grafiky}
                                   settextstyle(pfont,0,pvelikostpisma);
                                   rozmerykurzoru(textwidth('A'),textheight256('A'));
                                   end;

End;{loadsetup}

procedure SaveSetup;{ulozeni nastaveni}
var f:text;
Begin
assign(f,'TURBOPAD.CFG');
rewrite(f);
if ioresult=0 then begin
                   writeln(f,'Konfiguracni soubor pro Mircosoft Turbopad. Pokud se chystate tento program');
                   writeln(f,'spustit na svem pocitaci poprve, radsi tento soubor smazte. Vytvari se');
                   writeln(f,'automaticky pokazde, kdyz v programu zmenite nastaveni.');
                   writeln(f);
                   writeln(f,'naposledy otevreny sesit (max. 5 znaku):');
                   writeln(f,jmenos);
                   writeln(f,'na strance:');
                   writeln(f,cislos);
                   writeln(f,'Tyto dve hodnoty mente jen v pripade problemu.');
                   writeln(f,'cislo graficke karty (0 - VGA, 1 - SVGA):');
                   writeln(f,karta);
                   writeln(f,'cislo grafickeho rezimu (zalezi na cislu karty):');
                   writeln(f,rezim);

                   writeln(f,'Nasleduje ruzne uzivatelske nastaveni.');
                   writeln(f,'kresleni od ruky:');
                   writeln(f,bts(kresleniodruky));
                  writeln(f,'delka useku pri kresleni od ruky (cim mensi cislo, tim hladsi cara, ale vetsi naroky na pamet):');
                   writeln(f,delkacarky);
                   writeln(f,'mezera mezi radky v pixelech:');
                   writeln(f,meziradky);
                   writeln(f,'sirka tabulatoru ve znacich:');
                   writeln(f,sirkatabulatoru);
                   writeln(f,'font:');
                   writeln(f,pfont);
                   writeln(f,'velikost pisma:');
                   writeln(f,pvelikostpisma);
                   writeln(f,'barva pozadi (papiru):');
                   writeln(f,barvapozadi);
                   writeln(f,'barva pro kresleni:');
                   writeln(f,barvacary);
                   writeln(f,'barva pro psani:');
                   writeln(f,barvatextu);
                   writeln(f,'potvrzeni uspesneho ulozeni:');
                   writeln(f,bts(potvrzeniprisave));
                   writeln(f,'potvrzeni uspesneho otevreni souboru:');
                   writeln(f,bts(potvrzenipriload));
                   writeln(f,'hlaseni vsech chyb:');
                   writeln(f,bts(hlasitchyby));
                   writeln(f,'automaticke ukladani pri ukonceni programu:');
                   writeln(f,bts(autosaveb));
                   writeln(f,'automaticke ukladani pri listovani mezi strankami:');
                   writeln(f,bts(autosaveb2));
                   writeln(f,'poloha pocatku souradnic (x,y) v pixelech:');
                   writeln(f,ussx);
                   writeln(f,ussy);
                   writeln(f,'Konec souboru.');
                   close(f);
                   if(ioresult<>0)and hlasitchyby then infokno(getmaxx shr 1,getmaxy shr 1,
                    'Problem pri ukladani nastaveni (asi nic vazneho).',ano);
                   end
              else begin
                   if hlasitchyby then
                    if global_grafrezim=0 then begin
                                               writeln;
                                         writeln('Disk je zrejme chranen proti zapisu, takze se nepodarilo ulozit nastaveni.');
                                               write(' Pokracujte libovolnou klavesou...');
                                               kresetuj;kcekej;kresetuj;
                                               writeln;
                                               end
                                          else infokno(getmaxx shr 1,getmaxy shr 1,'Disk je zrejme chranen proti zapisu, '+
                                           'takze se nepodarilo ulozit nastaveni.',ano);
                   end;
End;{savesetup}

function StartGrafiky:boolean;{spusteni grafickeho rezimu, kdyz se to povede, vraci true}
Begin
if karta=0 then begin
                initgraph(vgac,rezim,'');
                if graphresult=0 then begin
                                      initmys;
                                      startgrafiky:=ano;
                                      global_grafrezim:=(vgac shl 8) or rezim;
                                      end
                                 else startgrafiky:=ne;
                end
           else if karta=1 then begin
                                initgraph(svgac,rezim,'');
                                if graphresult=0 then begin
                                                      initmys;
                                                      startgrafiky:=ano;
                                                      global_grafrezim:=(svgac shl 8) or rezim;
                                                      end
                                                 else startgrafiky:=ne;
                                end;
End;{startgrafiky}

procedure KonecGrafiky;{no comment}
Begin
closegraph;
global_grafrezim:=gm80x25x16;
End;{konecgrafiky}

procedure VyhodSeznam;{vymaze cely seznam prvku z pameti}
Begin
prvekp:=posledni;
while prvekp<>nil do begin
                     prvekp:=prvekp^.predchozi;
                     dispose(posledni);
                     posledni:=prvekp;
                     end;
prvni:=nil; posledni:=nil;
End;{vyhodseznam}

function JmenoSouboruF:string;{pomocna, vraci cele jmeno aktualniho souboru (stranky)}
var str3:string[3];
Begin
str(cislos,str3);
while byte(str3[0])<3 do str3:='0'+str3;
jmenosouboruf:=jmenos+'\'+jmenos+str3+'.STR';
End;{jmenosouboruf}

procedure UlozHlavicku;{hlavicka sesitu je ten DAT soubor}
var f:text;
Begin
assign(f,jmenos+'\'+jmenos+'.DAT');
rewrite(f);
if ioresult=0 then begin
                   writeln(f,'Nazev sesitu:');
                   writeln(f,celejmeno);
                   writeln(f,'Pocet stranek sesitu (nemenit!):');
                   writeln(f,pocetstranek);
                   writeln(f,'Naposledy byl sesit zavren na strane (cislovano od nuly):');
                   writeln(f,cislos);
                   writeln(f,'Jen pro cteni?');
                   writeln(f,bts(readonly));
                   writeln(f,'Chraneno heslem?');
                   writeln(f,bts(zaheslovano));
                   writeln(f);
                   writeln(f,'Naposledy pouzite pismo a styl psani:');
                   writeln(f,'cislo fontu:');
                   writeln(f,pfont);
                   writeln(f,'velikost pisma:');
                   writeln(f,pvelikostpisma);
                   writeln(f,'barva pisma:');
                   writeln(f,barvatextu);
                   writeln(f,'sirka tabulatoru (ve znacich):');
                   writeln(f,sirkatabulatoru);
                   writeln(f,'mezera mezi radky (v pixelech):');
                   writeln(f,meziradky);
                   writeln(f,'Naposledy nastavene parametry kresleni:');
                   writeln(f,'kresli se od ruky?');
                   writeln(f,bts(kresleniodruky));
                   writeln(f,'delka useku cary pri kresleni od ruky:');
                   writeln(f,delkacarky);
                   writeln(f,'barva pro kresleni:');
                   writeln(f,barvacary);
                   writeln(f,'vzorek vyplne obdelniku a elipsy:');
                   writeln(f,pvypln);
                   writeln(f,'Konec souboru.');
                   close(f);
                   if(ioresult<>0)and hlasitchyby then infokno(getmaxx shr 1,getmaxy shr 1,
                    'Problem pri ukladani hlavicky (asi nic vazneho).',ano);
                   end
              else begin
                   if hlasitchyby or potvrzeniprisave then
                    infokno(getmaxx shr 1,getmaxy shr 1,'Disk je asi chranen proti zapisu, '+
                                           'takze se nepodarilo ulozit hlavicku sesitu.',ano);
                   end;
End;{ulozhlavicku}

procedure NactiHlavicku;
var f:text;
    pomstr:string[3];
    info:searchrec;
    nazev:string;
Begin
nazev:=jmenos+'\'+jmenos+'.DAT';
assign(f,nazev);
reset(f);
if ioresult=0 then begin
                   readln(f);
                   readln(f,celejmeno);
                   readln(f);
                   readln(f,pocetstranek);
                   readln(f);
                   readln(f,cislos);
                   readln(f);
                   readln(f,pomstr); readonly:=stb(pomstr);
                   readln(f);
                   readln(f,pomstr); zaheslovano:=stb(pomstr);
                   readln(f);
                   readln(f);
                   readln(f);
                   readln(f,pfont);
                   readln(f);
                   readln(f,pvelikostpisma);
                   readln(f);
                   readln(f,barvatextu);
                   readln(f);
                   readln(f,sirkatabulatoru);
                   readln(f);
                   readln(f,meziradky);
                   readln(f);
                   readln(f);
                   readln(f,pomstr); kresleniodruky:=stb(pomstr);
                   readln(f);
                   readln(f,delkacarky);
                   readln(f);
                   readln(f,barvacary);
                   readln(f);
                   readln(f,pvypln);
                   {zbyva uz jen radek s textem 'Konec souboru'}
                   close(f);
                   if(ioresult<>0)and hlasitchyby then infokno(getmaxx shr 1,getmaxy shr 1,
                    'Problem pri nacitani hlavicky sesitu (asi nic vazneho).',ano);
                   end
              else begin
                   if hlasitchyby or potvrzeniprisave then
                    infokno(getmaxx shr 1,getmaxy shr 1,'Sesit bud nema hlavicku nebo se ji nepodarilo precist. '+
                                           'Pouziji se tedy vychozi hodnoty a hlavicka se automaticky '+
                                           'vytvori pri nejblizsim ulozeni.',ano);
                   zaheslovano:=ne; readonly:=ne;
                   celejmeno:=jmenos;
                   pocetstranek:=0;
                   if existujeadresar(jmenos) then
                     begin{spocitani stranek}
                     findfirst(jmenos+'\*.str',anyfile,info);
                     while doserror=0 do begin
                                         inc(pocetstranek);
                                         findnext(info);
                                         end;
                     end;
                   cislos:=pocetstranek;{nalistovani posledni stranky}
                   end;
End;{nactihlavicku}

procedure Save;{ulozi aktualni stranku a hlavicku sesitu}
var f:file;
    soubor:string[18];
    b,i:byte;
    info:searchrec;
Begin
if prvni=nil then exit;{aby se nevytvarely prazdne soubory}
findfirst(jmenos,directory,info);{existuje prislusny sesit (adresar)?}
if doserror<>0 then begin{neexistuje:}
                    mkdir(jmenos);{vytvorime ho...}
                    if ioresult<>0 then{...a kdyz se to nepovedlo, tak...}
                      begin
                      if hlasitchyby or potvrzeniprisave then
                       infokno(getmaxx shr 1,getmaxy shr 1,'Nepovedlo se vytvorit novy adresar, ulozeni se nezdarilo.',ano);
                      exit;{...se ukladat nebude}
                      end;
                    end;
ulozhlavicku;
soubor:=jmenosouboruf;{sestaveni celeho jmena souboru (tedy napr.: SESIT\SESIT001.STR)}
if not existujesoubor(soubor) then inc(pocetstranek);{kdyz vytvarime novy soubor, tak bude urcite o stranku vic}
if zaheslovano then assign(f,'TMP.$$$')
               else assign(f,soubor);
rewrite(f,1);
if ioresult=0 then
 begin
 prvekp:=prvni;
 while prvekp<>nil do with prvekp^ do
   begin
   blockwrite(f,cotoje,1);
   blockwrite(f,barva,1);
   blockwrite(f,x,2);
   blockwrite(f,y,2);
   if (cotoje>ptext)then begin
                         blockwrite(f,x2,2);
                         blockwrite(f,y2,2);
                         end;
   if cotoje=pobdelnik then blockwrite(f,vypln,1);
   if cotoje=ptext then begin
                        b:=(font and 15)or(velikostpisma shl 4);
                        blockwrite(f,b,1);
                        b:=byte(ret[0]);
                        blockwrite(f,b,1);
                        for i:=1 to b do blockwrite(f,ret[i],1);
                        end;
   prvekp:=prvekp^.dalsi;
   end;{while}
 b:=pinfo;
 blockwrite(f,b,1);
 blockwrite(f,barvapozadi,1);{tohle je az na konci kvuli moznosti zasifrovat soubor. Pet nul na zacatku souboru by byla skvela
                               prilezitost k prolomeni hesla.}
 blockwrite(f,ussx,2);
 blockwrite(f,ussy,2);
 close(f);
 if ioresult=0 then begin
                    if zaheslovano then begin
                                        if sifrujsoubor('TMP.$$$',soubor,heslo) and vymazsoubor('TMP.$$$')
                                            then begin
                                                 if potvrzeniprisave then infokno(getmaxx shr 1,getmaxy shr 1,
                                                                          'Soubor byl uspesne zakodovan a ulozen.',ano);
                                                 end
                                            else begin
                                                 if potvrzeniprisave or hlasitchyby then
                                                  infokno(getmaxx shr 1,getmaxy shr 1,
                                                 'Nastala chyba nekde behem sifrovani souboru, ulozeni se asi nezdarilo.',ano);
                                                 end;
                                        end
                                   else if potvrzeniprisave then infokno(getmaxx shr 1,getmaxy shr 1,
                                                                 'Soubor byl uspesne ulozen.',ano);
                    end
               else begin
                    if potvrzeniprisave or hlasitchyby then infokno(getmaxx shr 1,getmaxy shr 1,
                     'Soubor bud nesel zavrit nebo se do nej nepodarilo zapisovat, kazdopadne ulozeni se asi nezdarilo.',ano);
                    end;
 end{if ioresult po rewrite = 0}
else if hlasitchyby or potvrzeniprisave then infokno(getmaxx shr 1,getmaxy shr 1,
                                              'Soubor nesel otevrit pro zapis, ulozeni se nezdarilo.',ano);
End;{save}

procedure KresliBarvy;{vybarvi tlacitka pro nastaveni barev (na panelu tlacitek)}
Begin
setwritemode(0);
{barva car:}
setfillstyle(1,barvacary); setcolor(barvacary);bar(191,19,200,25);
fillellipse(199,28,5,3);line(191,32,191+15,32-11);
{pozadi:}
setfillstyle(1,barvapozadi);bar(213,17,230,33);
{barva textu:}
setcolor(barvatextu);line(239,31,239+4,31-12);line(247,31,247+5,31);line(241,27,241+7,27);
line(242,18,242+2,18);setlinestyle(0,$F18F,3);line(245,18,245+5,18+13);setlinestyle(0,$F18F,1);
line(237,31,237+5,31);
setwritemode(1);
End;{kreslibarvy}

procedure KresliTitulek;{nakresli modrou listu s nadpisem na panelu tlacitek}
Begin
setfillstyle(1,1); bar(2,2,getmaxx-2,12);
setcolor(15); settextstyle(0,0,1); outtextxy(6,4,'Mircosoft TurboPad - '+celejmeno+' (stranka '+nastr(cislos)+')');
settextstyle(pfont,0,pvelikostpisma);
konect.zobraz;
setwritemode(0); konect.kresli(0); setwritemode(1);
End;{kreslititulek}

procedure KresliPanel;{vykresli panel tlacitek}
const x=0; y=0;
var cu:array[1..4]of pointtype;
Begin
kvyp;
setwritemode(0);
setfillstyle(1,15); bar(0,0,getmaxx,0); bar(0,1,0,pred(paneldy));
setfillstyle(1,8); bar(0,paneldy,getmaxx,paneldy); bar(getmaxx,1,getmaxx,pred(paneldy));
setfillstyle(1,7); bar(1,1,pred(getmaxx),pred(paneldy));
{exportovano z AlmostCADu, proto je to tak prasacky napsane:}
{zpet:}
setcolor(9); setlinestyle(0,$F18F,3);line(x+21,y+25,x+21-13,y+25);line(x+8,y+25,x+8+7,y+25-4);line(x+8,y+25,x+8+7,y+25+4);
{dal:}
line(x+31,y+25,x+31+13,y+25);line(x+44,y+25,x+44-7,y+25-4);line(x+44,y+25,x+44-7,y+25+4);
{save, load:}
setcolor(11); setfillstyle(9,11); setlinestyle(0,0,1); fillellipse(x+60,y+28,8,5);fillellipse(x+83,y+28,8,5);setcolor(9);
setlinestyle(0,0,3);
line(x+60,y+18,x+60,y+18+7);line(x+60,y+25,x+60+4,y+25-4);line(x+60,y+25,x+60-4,y+25-4);
line(x+83,y+26,x+83,y+26-8);line(x+83,y+18,x+83-4,y+18+5);line(x+83,y+18,x+83+4,y+18+5);
{soubor:}
setfillstyle(1,14);bar(x+99,y+22,x+114,y+32);bar(x+100,y+21,x+107,y+21);bar(x+101,y+20,x+106,y+20);
{elipsa:}
setcolor(9); setlinestyle(0,$F18F,1);line(x+120,y+26,x+120+18,y+26);line(x+129,y+18,x+129,y+18+15);setcolor(12);
ellipse(x+129,y+26,0,360,8,5);
{obdelnik:}
setfillstyle(1,12);bar(x+145,y+21,x+160,y+30);setcolor(9);rectangle(x+144,y+20,x+161,y+31);
{styl kresleni:}
setcolor(6); setfillstyle(1,6);cu[1].x:=x+171; cu[1].y:=y+27;cu[2].x:=x+179; cu[2].y:=y+19;cu[3].x:=x+181; cu[3].y:=y+21;
cu[4].x:=x+173; cu[4].y:=y+29;fillpoly(4,cu);setcolor(14);line(x+171,y+28,x+171-1,y+28+2);line(x+170,y+31,x+170+2,y+31-2);
putpixel(x+171,y+29,14);putpixel(x+170,y+31,0);setcolor(8);line(x+171,y+32,x+171+4,y+32);line(x+176,y+31,x+176+3,y+31-1);
line(x+181,y+30,x+181+1,y+30+2);line(x+172,y+29,x+172+8,y+29-8);
{font:+++++++++++++++++++++++++++++++++++++++++++++}
setfillstyle(1,0);setcolor(0);bar(x+261,y+19,x+263,y+31);line(x+270,y+19,x+270,y+19+4);bar(x+265,y+25,x+266,y+27);
line(x+264,y+18,x+264-3,y+18+2);line(x+259,y+20,x+259+4,y+20-3);line(x+264,y+20,x+264+3,y+20-1);line(x+267,y+19,x+267+4,y+19+1)
;line(x+263,y+21,x+263+5,y+21+1);line(x+268,y+22,x+268+1,y+22-2);line(x+269,y+19,x+269,y+19+3);line(x+272,y+21,x+272-2,y+21+2);
bar(x+271,y+30,x+273,y+32);line(x+264,y+26,x+264+2,y+26-2);line(x+266,y+24,x+266+2,y+24+2);line(x+268,y+26,x+268-3,y+26+1);
line(x+260,y+31,x+260+4,y+31);line(x+260,y+31,x+260+4,y+31+1);bar(x+266,y+20,x+268,y+21);
{vyska pisma:}
setcolor(8);line(x+283,y+31,x+283+3,y+31-11);setlinestyle(0,$F18F,3);line(x+287,y+20,x+287+3,y+20+11);setlinestyle(0,$F18F,1);
line(x+285,y+28,x+285+4,y+28);line(x+282,y+31,x+282+2,y+31);line(x+286,y+20,x+286-1,y+20);setcolor(9);
line(x+288,y+20,x+288+11,y+20);line(x+290,y+32,x+290+9,y+32);line(x+297,y+32,x+297,y+32-12);line(x+297,y+20,x+297-2,y+20+3);
line(x+297,y+20,x+297+2,y+20+3);line(x+297,y+32,x+297-2,y+32-2);line(x+297,y+32,x+297+2,y+32-2);
{USS:}
setcolor(4);line(x+313,y+17,x+313,y+17+16);line(x+305,y+25,x+305+17,y+25);putpixel(x+315,y+23,4);
{setup:}
setcolor(8); setfillstyle(1,8);cu[1].x:=x+331; cu[1].y:=y+28;cu[2].x:=x+337; cu[2].y:=y+22;cu[3].x:=x+339; cu[3].y:=y+24;
cu[4].x:=x+333; cu[4].y:=y+30;fillpoly(4,cu);fillellipse(x+340,y+20,4,4);fillellipse(x+332,y+29,4,4);
setfillstyle(1,7);bar(x+339,y+19,x+345,y+21);bar(x+327,y+28,x+332,y+31);
{help:}
setcolor(14);settextstyle(0,0,2);outtextxy(x+353,y+19,'?');settextstyle(pfont,0,pvelikostpisma);
{to ostatni:}
kreslibarvy;
kreslititulek;
for i:=0 to 15 do tlacitka[i].zobraz;
kzap;
End;{kreslipanel}

procedure KresliPrvek;{vykresli prvek, na ktery ukazuje Prvekp}
Begin
setwritemode(0);
with prvekp^ do
case cotoje of ptext:begin
                     setcolor(barva);
                     settextstyle(font,0,velikostpisma);
                     outtextxy(ussx+x,ussy+y,ret);
                     settextstyle(pfont,0,pvelikostpisma);
                     end;
               pcara:begin
                     setcolor(barva);
                     line(ussx+x,ussy+y,ussx+x+x2,ussy+y+y2);
                     end;
               pobdelnik:if vypln=0 then begin
                                         setcolor(barva);
                                         rectangle(ussx+x,ussy+y,ussx+x+x2,ussy+y+y2);
                                         end
                                    else begin
                                         setfillstyle(vypln,barva);
                                         bar(ussx+x,ussy+y,ussx+x+x2,ussy+y+y2);
                                         end;
               pelipsa:begin
                       setcolor(barva);
                       if vypln=0 then ellipse(ussx+x,ussy+y,0,360,x2,y2)
                                  else begin
                                       setfillstyle(vypln,barva);
                                       fillellipse(ussx+x,ussy+y,x2,y2);
                                       end;
                       end;
               end;
setwritemode(1);
End;{kresliprvek}

procedure Prekresli;{vykresli obsah stranky, pritom mozna pocmara panel tlacitek}
Begin
kvyp;
setfillstyle(1,barvapozadi);
bar(0,succ(paneldY),getmaxx,getmaxy);
prvekp:=prvni;
while prvekp<>nil do begin
                     kresliprvek;
                     prvekp:=prvekp^.dalsi;
                     end;
prvekp:=posledni;
kzap;
End;{prekresli}

procedure Load;{nacte a vykresli stranku}
var f:file;
    soubor:string[18];
    b,i:byte;
    info:searchrec;
    error:boolean;
{}function UlozPrvek2:boolean;{ulozi na konec seznamu prave nacteny prvek, pokud se to povedlo, vraci true}
{}var pom:uknaprvek;
{}Begin
{}if maxavail<sizeof(prvekt) then ulozprvek2:=false
{}                           else
{} begin
{} new(pom);{vytvorime novy prvek...}
{} with pom^ do begin{...hodime do nej prislusne hodnoty...}
{}              cotoje:=pcotoje;
{}              x:=px; y:=py; x2:=px2; y2:=py2;
{}              barva:=pbarva; vypln:=pvypln;
{}              velikostpisma:=pvelikostpisma; font:=pfont;
{}              ret:=pret; dalsi:=nil;
{}              end;
{} if posledni=nil then begin{...a vlozime ho na konec seznamu}
{}                      prvni:=pom; posledni:=pom; prvekp:=pom;
{}                      pom^.predchozi:=nil;
{}                      end
{}                 else begin
{}                      pom^.predchozi:=posledni;
{}                      posledni^.dalsi:=pom;
{}                      posledni:=pom;
{}                      end;
{} prvekp:=pom;
{} ulozprvek2:=true;
{} end;
{}End;{ulozprvek2}
Begin{load}
vypnipsani; error:=ne;
findfirst(jmenos,directory,info);{existuje prislusny sesit (adresar)?}
if doserror=0 then
 begin
 soubor:=jmenosouboruf;{sestaveni celeho jmena souboru (tedy napr.: SESIT\SESIT001.STR)}
 assign(f,soubor);
 reset(f,1);
 if ioresult=0 then{kdyz se soubor povedlo otevrit:}
  begin
  vyhodseznam;
  while not(error or eof(f)) do
    begin
    blockread(f,pcotoje,1);
    blockread(f,pbarva,1);
    blockread(f,px,2);
    blockread(f,py,2);
    if pcotoje=pinfo then begin
                          barvapozadi:=pbarva;
                          ussx:=px;
                          ussy:=py;
                          end
     else begin
          if (pcotoje>ptext)then begin
                                 blockread(f,px2,2);
                                 blockread(f,py2,2);
                                 end;
          if pcotoje=pobdelnik then blockread(f,pvypln,1);
          if pcotoje=ptext then begin
                                blockread(f,b,1);
                                pfont:=b and 15; pvelikostpisma:=b shr 4;
                                blockread(f,b,1);
                                pret[0]:=chr(b);
                                for i:=1 to b do blockread(f,pret[i],1);
                                end;
          if not ulozprvek2 then begin
                                 if hlasitchyby or potvrzenipriload then infokno(getmaxx shr 1,getmaxy shr 1,
                                         'Nedostatek mista v pameti, soubor se asi nenacetl cely.',ano);
                                 error:=ano;
                                 end;
          end;
    end;
  close(f);
  if ioresult=0 then begin
                     if potvrzenipriload then infokno(getmaxx shr 1,getmaxy shr 1,'Stranka byla uspesne nactena.',ano);
                     end
                else if potvrzenipriload or hlasitchyby then infokno(getmaxx shr 1,getmaxy shr 1,
                                  'Bud neslo ze souboru cist nebo nesel zavrit, kazdopadne se asi nacteni nepovedlo.',ano);
  end
 else if hlasitchyby or potvrzenipriload then infokno(getmaxx shr 1,getmaxy shr 1,
                                                  'Nacteni se nepovedlo, stranka patrne dosud neexistuje.',ano);
 end
else begin{neexistuje:}
     if hlasitchyby or potvrzenipriload then
        infokno(getmaxx shr 1,getmaxy shr 1,'Sesit (adresar) neexistuje.',ano);
     end;
prekresli;
kreslipanel;
End;{load}

procedure UlozPrvek;{ulozi na konec seznamu prave kresleny prvek}
var pom:uknaprvek;
Begin
while maxavail<sizeof(prvekt) do begin
                        {kdyz dojde pamet, tak se automaticky nalistuje dalsi stranka. Prakticky nemozne, ale co kdyby.}
                                 save;
                                 vyhodseznam;
                                 inc(cislos);
                                 load;
                                 if potvrzeniprisave or potvrzenipriload or hlasitchyby
                           then infokno(getmaxx shr 1,getmaxy shr 1,'Dosla pamet, tak se muselo prejit na dalsi stranku.',ano);
                                 end;
new(pom);
with pom^ do begin
             cotoje:=pcotoje;
             x:=px-ussx; y:=py-ussy; x2:=px2-px; y2:=py2-py;
             barva:=pbarva; vypln:=pvypln;
             velikostpisma:=pvelikostpisma; font:=pfont;
             ret:=pret; dalsi:=nil;
             end;
if posledni=nil then begin
                     prvni:=pom; posledni:=pom; prvekp:=pom;
                     pom^.predchozi:=nil;
                     end
                else begin
                     pom^.predchozi:=posledni;
                     posledni^.dalsi:=pom;
                     posledni:=pom;
                     end;
prvekp:=pom;
End;{ulozprvek}

procedure VymazPrvek;{vymaze ze seznamu prvek, na ktery ukazuje Prvekp}
var pom:uknaprvek;
Begin
if prvekp=nil then exit;
if prvekp=prvni then if prvekp=posledni then begin
                                             prvni:=nil; posledni:=nil;
                                             end
                                        else begin{rusime prvni prvek}
                                             prvni:=prvekp^.dalsi;
                                             prvni^.predchozi:=nil;
                                             end
                else if prvekp=posledni then begin{rusime posledni prvek}
                                             posledni:=prvekp^.predchozi;
                                             posledni^.dalsi:=nil;
                                             end
                                        else begin{rusime prvek nekde uprostred}
                                             prvekp^.predchozi^.dalsi:=prvekp^.dalsi;
                                             prvekp^.dalsi^.predchozi:=prvekp^.predchozi;
                                             end;
pom:=prvekp;
prvekp:=prvekp^.predchozi;
dispose(pom);
if prvekp=nil then prvekp:=posledni;
end;{vymazprvek}

procedure Setup;{nastaveni}
const stranek=4;
var delkacarkyO,meziradkyO,sirkatabulatoruO:ciselnaosa;
    potvrzeniprisavez,potvrzenipriloadz,hlasitchybyz,autosavez,autosavez2:zatrzitko;
    grafikaP,rozliseniP:prepinac;
    okt,cancelt:tlacitko;
    okb,cancelb:boolean;
    savekarta,saverezim:integer;
    pos:posuvnik;
    kartatmp,rozltmp:byte;
Begin
kvyp;
okb:=ne; cancelb:=ne; rozltmp:=rezim; kartatmp:=karta;
vokno(ox,oy,319,199,'Nastaveni');
setwritemode(0); nastavkurzor(0); settextstyle(0,0,1); savekarta:=karta; saverezim:=rezim;
pos.init(ox+302,oy+15,151,stranek,stpstranka);
okt.init(ox+3,oy+180,'           OK           ',1);
cancelt.init(ox+210,oy+180,' Zrusit ',1);
grafikap.init(ox+3,oy+30,2,karta,'Graficky adapter:','EGA/VGA','SVGA','','','','');
if kartatmp=0 then rozlisenip.init(ox+3,oy+70,4,rozltmp,
                                             'Rozliseni:','640 x 200','640 x 350','640 x 480','640 x 350 (4 barvy)','','')
                                          else if kartatmp=1 then rozlisenip.init(ox+3,oy+70,5,rozltmp,'Rozliseni:',
                                                             '320 x 200','640 x 400','640 x 480','800 x 600','1024 x 768','');
meziradkyO.init(ox+3,oy+25,20,100,meziradky,7,ano);
sirkatabulatoruO.init(ox+3,oy+70,50,100,sirkatabulatoru,7,ano);
delkacarkyO.init(ox+3,oy+25,20,100,delkacarky,7,ano);
potvrzeniprisavez.init(ox+3,oy+17,'Potvrzovani pri ukladani',potvrzeniprisave);
potvrzenipriloadz.init(ox+3,oy+32,'Potvrzovani pri nacitani',potvrzenipriload);
hlasitchybyz.init(ox+3,oy+47,'Hlasit chyby',hlasitchyby);
autosavez.init(ox+3,oy+62,'Automaticke ukladani pri ukonceni',autosaveb);
autosavez2.init(ox+3,oy+77,'Automaticke ukladani pri listovani',autosaveb2);
repeat
kvyp;
clrvokno;
case stpstranka of
 0:begin{grafika}
   grafikap.zobraz;
   rozlisenip.zobraz;
    repeat
    cekej;
    case grafikap.klik of 1:begin
                            kvyp;
                            clrvokno;
                            grafikap.zobraz;
                            kartatmp:=grafikap.vybrano;
                            if kartatmp=0 then rozlisenip.init(ox+3,oy+70,4,rozltmp,
                                             'Rozliseni:','640 x 200','640 x 350','640 x 480','640 x 350 (4 barvy)','','')
                                          else if kartatmp=1 then rozlisenip.init(ox+3,oy+70,5,rozltmp,'Rozliseni:',
                                                             '320 x 200','640 x 400','640 x 480','800 x 600','1024 x 768','');
                            end;
                          2:infokno(xmys,ymys,'Program podporuje graficke karty EGA, VGA a SVGA, kazda karta podporuje jina '+
                                              'rozliseni. Vyberte si, co vam nejlip vyhovuje a co vas hadrware zvladne.',ano);
                          end;
    if rozlisenip.klik=2 then infokno(xmys,ymys,'Vyberte si takove rozliseni, jake vam a vasemu monitoru nebo displeji'+
                                                ' vyhovuje nejlepe.',ano);
    if okt.klik=1 then okb:=ano;
    if cancelt.klik=1 then cancelb:=ano;
    if keypressed then case readkey of #13:okb:=ano;
                                       #27:cancelb:=ano;
                                       #0:kresetuj;
                                       end;
    until(pos.refresh<>stpstranka)or okb or cancelb;
   end;
 1:begin{psani}
   setcolor(0);
   outtextxy(ox+3,oy+15,'Mezera mezi radky [pix]');
   outtextxy(ox+3,oy+55,'Sirka tabulatoru [zn]');
   meziradkyo.zobraz;
   sirkatabulatoruo.zobraz;
    repeat
    cekej;
    meziradkyO.refresh;
    sirkatabulatoruO.refresh;
    if okt.klik=1 then okb:=ano;
    if cancelt.klik=1 then cancelb:=ano;
    if keypressed then case readkey of #13:okb:=ano;
                                       #27:cancelb:=ano;
                                       #0:kresetuj;
                                       end;
    until(pos.refresh<>stpstranka)or okb or cancelb;
   end;
 2:begin{kresleni}
   setcolor(0);
   outtextxy(ox+3,oy+15,'Nekvalita kresby');
   delkacarkyo.zobraz;
    repeat
    cekej;
    delkacarkyO.refresh;
    if okt.klik=1 then okb:=ano;
    if cancelt.klik=1 then cancelb:=ano;
    if keypressed then case readkey of #13:okb:=ano;
                                       #27:cancelb:=ano;
                                       #0:kresetuj;
                                       end;
    until(pos.refresh<>stpstranka)or okb or cancelb;
   end;
 3:begin{hlasky apod}
   potvrzeniprisavez.zobrazcele;
   potvrzenipriloadz.zobrazcele;
   hlasitchybyz.zobrazcele;
   autosavez.zobrazcele;
   autosavez2.zobrazcele;
    repeat
    cekej;
    if potvrzeniprisavez.klik=2 then infokno(xmys,ymys,
    'Pokud je toto zatrzene, objevi se po kazdem ulozeni okno s informaci o uspesnem ulozeni.',ano);
    if potvrzenipriloadz.klik=2 then infokno(xmys,ymys,
    'Pokud je toto zatrzene, objevi se po kazdem nacteni ze souboru okno s informaci o tom, jestli se to povedlo.',ano);
    if hlasitchybyz.klik=2 then infokno(xmys,ymys,
    'Pokud je toto zatrzene, objevi se pri kazde chybe (otevreni neexistujiciho souboru, '+
    'nedostatek pameti apod.) chybove hlaseni.',ano);
    if autosavez.klik=2 then infokno(xmys,ymys,
    'Pokud je tohle zatrzene, automaticky se uklada aktualni stranka pri ukonceni programu.',ano);
    if autosavez2.klik=2 then infokno(xmys,ymys,
    'Pokud je toto zatrzene, automaticky se uklada aktualni stranka pri prepinani mezi strankami.',ano);
    if okt.klik=1 then okb:=ano;
    if cancelt.klik=1 then cancelb:=ano;
    if keypressed then case readkey of #13:okb:=ano;
                                       #27:cancelb:=ano;
                                       #0:kresetuj;
                                       end;
    until(pos.refresh<>stpstranka)or okb or cancelb;
   end;
 end;{case}
stpstranka:=pos.cislobloku;
until okb or cancelb;
if okb then begin
            hlasitchyby:=hlasitchybyz.zatrzeno;
            potvrzeniprisave:=potvrzeniprisavez.zatrzeno;
            potvrzenipriload:=potvrzenipriloadz.zatrzeno;
            autosaveb:=autosavez.zatrzeno;
            autosaveb2:=autosavez2.zatrzeno;

            delkacarky:=delkacarkyO.hodnota;
            meziradky:=meziradkyO.hodnota;
            sirkatabulatoru:=sirkatabulatoruO.hodnota;

            karta:=grafikap.vybrano;
            rezim:=rozlisenip.vybrano;
            if (karta<>savekarta)
               or(rezim<>saverezim)then begin
                                        konecgrafiky;
                                        if startgrafiky then begin
                                                             seridvokno; prekresli; kreslipanel;
                                                             if not anoneokno('Rozliseni bylo uspesne nastaveno.|'+
                                                                              'Prejete si ho tak nechat?')
                                                                 then begin
                                                                      karta:=savekarta;
                                                                      rezim:=saverezim;
                                                                      konecgrafiky;
                                                                      if startgrafiky then seridvokno
                                                                                   else chyba('Totalni kolaps, smazte prosim'+
                                                                           ' soubor TURBOPAD.CFG a spustte program znovu.',0);
                                                                      end;          {^tohle nepredpokladam, ale co kdyby...}
                                                             end
                                                        else begin
                                                             karta:=savekarta; rezim:=saverezim;
                                                             if startgrafiky then begin
                                                                                  prekresli;kreslipanel;
                                                                                  infokno(getmaxx shr 1,getmaxy shr 1,
                                                      'Vybrane rozliseni se nepodarilo nastavit, bylo obnoveno puvodni.',ano);
                                                                                  end
                                                                             else chyba('Totalni kolaps, smazte prosim'+
                                                                           ' soubor TURBOPAD.CFG a spustte program znovu.',0);
                                                             end;
                                        end;
            end;
prekresli;
kreslipanel;
nastavkurzor(6);
setwritemode(1);
kzap;
settextstyle(pfont,0,pvelikostpisma);
End;{setup}

procedure Help;{napoveda}
const stranek=4;
var okt:tlacitko;
    okb:boolean;
    pos:posuvnik;
{}procedure cekani;
{}Begin
{}kzap;
{} repeat
{} cekej;
{} okb:=(okt.klik=1) or (keypressed and (readkey in [#13,#27,' ']));
{} until(pos.refresh<>hlpstranka)or okb;
{}End;{cekani}
Begin{help}
kvyp;
okb:=ne;
vokno(ox,oy,319,199,'Manual');
setwritemode(0); nastavkurzor(0); settextstyle(0,0,1);
pos.init(ox+302,oy+15,151,stranek,hlpstranka);
okt.init(ox+3,oy+180,'               Zavrit               ',1);
 repeat
 kvyp;
 clrvokno;
 case stpstranka of
  0:begin{obsah}
    outtextxy(ox+3,oy+15,'* UNDER CONSTRUCTION *');
    cekani;
    end;
  1:begin{psani}
    {++++++++++}
    cekani;
    end;
  2:begin
    {++++++++++}
    cekani;
    end;
  3:begin
    {++++++++++}
    cekani;
    end;
  end;{case}
 hlpstranka:=pos.cislobloku;
 until okb;
prekresli;
kreslipanel;
nastavkurzor(6);
setwritemode(1);
kzap;
settextstyle(pfont,0,pvelikostpisma);
End;{help}

procedure HIndex;{o uroven nahoru}
Begin
ulozprvek;
if alt=0 then begin
              velikostnormpisma:=pvelikostpisma;
              ynormpisma:=ymys;
              end;
if alt>=0 then begin
               if pvelikostpisma>1 then begin
                                        dec(pvelikostpisma);
                                        settextstyle(pfont,0,pvelikostpisma);
                                        seridkurzor;
                                        end;
               presunmys(xmys,ymys-textheight256('A')shr 1);{o pul vysky pisma nahoru}
               px:=xmys; py:=ymys; pret:=''; index:=0;
               end
          else begin{vracime se z dolniho indexu}
               if pvelikostpisma<velikostnormpisma then begin
                                                        presunmys(xmys,ymys-textheight256('A') shr 1-textheight256('A'));
                                                        inc(pvelikostpisma);
                                                        settextstyle(pfont,0,pvelikostpisma);
                                                        seridkurzor;
                                                        end
                                                   else presunmys(xmys,ymys-textheight256('A') shr 1);
               px:=xmys; py:=ymys; pret:=''; index:=0;
               end;
inc(alt);
End;{hindex}

procedure DIndex;{o uroven dolu}
Begin
ulozprvek;
if alt=0 then begin
              velikostnormpisma:=pvelikostpisma;
              ynormpisma:=ymys;
              end;
if alt<=0 then begin
               if pvelikostpisma>1 then begin
                                        dec(pvelikostpisma);
                                        settextstyle(pfont,0,pvelikostpisma);
                                        seridkurzor;
                                        end;
               presunmys(xmys,ymys+textheight256('A')shr 1);{o 0.5 vysky pisma dolu}
               px:=xmys; py:=ymys; resettext;
               end
          else begin{navrat z horniho indexu}
               presunmys(xmys,ymys+textheight256('A') shr 1);
               px:=xmys; py:=ymys; resettext;
               if pvelikostpisma<velikostnormpisma then begin
                                                        inc(pvelikostpisma);
                                                        settextstyle(pfont,0,pvelikostpisma);
                                                        seridkurzor;
                                                        end;
               end;
dec(alt);
End;{dindex}

procedure NormalText;{zruseni vsech indexu, pise se na normalni urovni}
Begin
ulozprvek;
if pvelikostpisma<>velikostnormpisma then begin
                                          pvelikostpisma:=velikostnormpisma;
                                          settextstyle(pfont,0,pvelikostpisma);
                                          seridkurzor;
                                          end;
presunmys(xmys,ynormpisma);
px:=xmys; py:=ymys; resettext;
alt:=0;
End;{normaltext}

