(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: TURBOPAD.PAS                                                   *)
(*  Obsah: superrychly texto-graficky editor                               *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava:                                                       *)
(*  Pro kompilaci: viz Uses + EGAVGA.OBJ, SVGA256.OBJ, TPADPROC.PAS        *)
(*                 a TPADTPRC.PAS                                          *)
(*  Pro spusteni: *.CHR soubory s fonty, ale jde i bez nich                *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program TurboPad;
{$B-,I-,X-}
uses dos,global,errmsg,disk,klavesy,konst,mys,graph,woknows,retezce,grafika;
label znovuelipsa,znovuobdelnik;

const ptext=0; pcara=1; pobdelnik=2; pelipsa=3; pinfo=4;{typy grafickych prvku}
      pisese:boolean=ne;{mame rozepsane slovo?}
      konecb:boolean=ne;{pomocna, pro ukonceni programu}
      paneldy=38;{y-ova souradnice dolniho okraje panelu nastroju}
      tzpet=0; tdal=1; tsave=2; tload=3; tsoubor=4; telipsa=5; tobdelnik=6;
      tkresleniodruky=7; tbarvacary=8; tbarvapozadi=9; tbarvatextu=10;
      tfont=11; tvelikostpisma=12; tuss=13; tnastaveni=14; tnapoveda=15;{tlacitka}
      thy=15; tdy=35; {horni a spodni hrana tlacitek na panelu}
      robdelnik=1; relipsa=2; {+++++++++++++++++++++++++}
      poslednifunkce:byte=robdelnik;
      Alt:shortint=0;{v jake jsme urovni pri psani horniho nebo dolniho indexu}
      stpstranka:byte=0;
      hlpstranka:byte=0;

type
uknaprvek=^prvekt;
prvekT=record
       cotoje:byte;
       x,y:integer;{souradnice}
       barva:byte;
       dalsi,predchozi:uknaprvek;{pro spojovy seznam}
       velikostpisma,font:byte;
       ret:string[130];
       x2,y2:integer;{relativni souradnice druheho bodu pro caru a obdelnik nebo polomery pro elipsu}
       vypln:byte;{jen pro obdelnik a elipsu}
       end;{prvekt}

var prvni,posledni,prvekp:uknaprvek;{pro dynamicky seznam}
    minx,miny:integer;{souradnice zacatku posledne psaneho slova, urcuje, kam se skoci po odradkovani}
    px,py,px2,py2:integer;{pro docasne ulozeni souradnic}
    pcotoje:byte;        {podobne:}
    pbarva,pvypln:byte;
    pret:string[130];{prave psany text}
    o:char;{pro cteni klavesnice}
    tlacitka:array[0..15] of tlacitko2;
    konect:tlacitko2;
    i:byte;
    vgac,svgac:integer;{kody grafickych karet, mely by se rovnat GDVGA a GDSVGA z jednotky Global, ale jeden nikdy nevi...}
    index:byte;{pro rezim vkladani - na jake pozici v textu je kurzor}
    VelikostNormPisma:byte;{pro psani indexu - jak velke je normalni pismo}
    YnormPisma:integer;{pro psani indexu - y-ova souradnice normalniho textu}
    ox,oy:integer;{souradnice okna pro nastaveni a napovedu}
    TPfont:font8x8;{cesky a recky font}
    {tohle vsechno se uklada do konfiguracniho souboru:}
    jmenos:string[5];{jmeno souboru, 3 znaky do osmi jsou vyhrazeny pro cislo}
    celejmeno:string[40];{cele jmeno sesitu (ulozi se do dat souboru)}
    cislos:word;{aktualni cislo souboru (stranky)}
    karta,rezim:integer;
    kresleniodruky:boolean;
    delkacarky:byte;{urcuje kvalitu kresleni od ruky, nedavat mensi nez 2}
    meziradky:byte;{mezera mezi radky, po stisknuti Enteru se skoci dolu o vysku pisma plus tohle}
    sirkatabulatoru:byte;
    pfont:byte; pvelikostpisma:byte;{nastaveni pisma}
    barvapozadi:byte;
    barvacary:byte;{barva pro kresleni}
    barvatextu:byte;{barva pro psani}
    potvrzeniprisave,
    potvrzenipriload,
    hlasitchyby,
    autosaveb,
    autosaveb2:boolean;
    readonly:boolean;{zakaze ukladani}
    zaheslovano:boolean;
    heslo:string;
    ussx,ussy:integer;{pocatek souradnic}
    pocetstranek:word;{pocet stranek v aktualnim sesite}

procedure ovladacvga; external; {$L egavga.obj}
procedure ovladacsvga; external; {$L svga256.obj}
{prilinkovane graficke BGI ovladace}

{$I TPADTPRC.PAS}
{$I TPADPROC.PAS}

BEGIN
{nacteni grafickych ovladacu:}
vgac:=installuserdriver('egavga',nil);
if registerbgidriver(@ovladacvga)<0 then chyba('Nefunguje registrace VGA.',2);
svgac:=installuserdriver('svga256',nil);
if registerbgidriver(@ovladacsvga)<0 then chyba('Nefunguje registrace SVGA.',1);
if(vgac=-11)and(svgac=-11)then chyba('Sezente si prosim grafickou kartu kompatibilni s VGA.',0);
{nacteni fontu:}
prvni:=nil; posledni:=nil; prvekp:=nil;
loadsetup;{nacteni nastaveni}
if not startgrafiky then chyba(
'Nepovedlo se spustit graficky rezim. Zkuste smazat soubor TURBOPAD.CFG a program'+
' restartovat, jestli to nepomuze, tak si nekde sezente mene zastaraly pocitac.',0);
seridvokno;
{if not nactifont8x8(tpfont,'tpfont.f88')then begin
                                             grabfont8x8(tpfont);
                                             infokno(getmaxx shr 1,getmaxy shr 1,
                                    'Chybi soubor TPFONT.F88, takze nebudou fungovat recka pismena a mozna ani ceska.',ano);
                                             end;}
repeat jmenos:=vloztextokno('Sesit:',5,jmenos,ano); until jmenos<>'';
{++++++++++++++++++}
for i:=0 to 15 do if i=tkresleniodruky then tlacitka[i].init(4+23*i,thy,21,21,nil,ano,kresleniodruky)
                                       else tlacitka[i].init(4+23*i,thy,21,21,nil,ne,ne);
{+++++++++++++++++++++++}
konect.init(getmaxx-11,3,8,8,@kreslikrizek,ne,ne);
nactihlavicku;
load;{nacteni souboru, pokud existuje}
{prekresli, kreslipanel, nastaveni fontu - obsazeno v Load}
nastavkurzor(6); rozmerykurzoru(textwidth('A'),textheight256('A'));
presunmys(10,paneldY+5); kzap;
 REPEAT{hlavni cyklus}
 cekejnacokoli;
 if pisese and not keypressed then begin
                                   pbarva:=barvatextu;
                                   ulozprvek;
                                   pisese:=ne; resettext;
                                   barvakurzoru(15);
                                   end;
 case tlacitka[tzpet].klik of 1:begin
                                tlacitka[tzpet].stisk;
                                kvyp;
                                if cislos>0 then begin
                                                 if prvni<>nil then save;
                                                 dec(cislos);
                                                 vyhodseznam;
                                                 load;
                                                 end;
                                kzap;
                                end;
                              2:case nabidka(xmys,ymys,'Predchozi|Na zacatek|-|napoveda')of
                                       1:begin
                                         kvyp;
                                         if cislos>0 then begin
                                                          if prvni<>nil then save;
                                                          dec(cislos);
                                                          vyhodseznam;
                                                          load;
                                                          end;
                                         end;
                                       2:begin
                                         kvyp;
                                         if prvni<>nil then save;
                                         cislos:=0;
                                         vyhodseznam;
                                         load;
                                         end;
                                       3:infokno(xmys,ymys,'Ulozi aktualni stranku a nalistuje predchozi.',ano);
                                       end;
                              end;
 case tlacitka[tdal].klik of 1:begin
                               tlacitka[tdal].stisk;
                               if cislos>=999 then infokno(getmaxx shr 1,getmaxy shr 1,'Blahopreji, podarilo se vam popsat '+
                             '1000 stranek! Bohuzel je to ale maximum, jestli chcete psat dal, musite zalozit novy sesit.',ano)
                                else
                               if prvni<>nil then{pokud je aktualni stranka prazdna, nejde se dal}
                                 begin
                                 if autosaveb2 then save;
                                 vyhodseznam;
                                 inc(cislos);
                                 load;
                                 end;
                               end;
                             2:case nabidka(xmys,ymys,'Dalsi|Na konec|-|Napoveda')of
                                 1:begin
                                   if cislos>=999 then infokno(getmaxx shr 1,getmaxy shr 1,'Blahopreji, podarilo se vam pops'+
                          'at 1000 stranek! Bohuzel je to ale maximum, jestli chcete psat dal, musite zalozit novy sesit.',ano)
                                    else
                                   if prvni<>nil then
                                     begin
                                     if autosaveb2 then save;
                                     vyhodseznam;
                                     inc(cislos);
                                     load;
                                     end;
                                   end;
                                 2:begin
                                   if (prvni<>nil)and autosaveb2 then begin
                                                                      save;
                                                                      vyhodseznam;
                                                                      end;
                                   if pocetstranek>0 then cislos:=pocetstranek-1;
                                   load;
                                   end;
                                 3:infokno(xmys,ymys,'Prejde na dalsi (nebo posledni) stranku. Pokud je zapnuta volba '+
                                                     '"Automaticke ukladani pri listovani", puvodni stranka se ulozi.',ano);
                                 end;
                             end;
 case tlacitka[tsave].klik of 1:begin
                                tlacitka[tsave].stisk;
                                save;
                                end;
                              2:infokno(xmys,ymys,'Ulozi aktualni stranku na disk.',ano);
                              end;
 case tlacitka[tload].klik of 1:begin
                                tlacitka[tload].stisk;
                                load;
                                end;
                              2:infokno(xmys,ymys,'Nacte aktualni stranku z disku. Protoze zde neni funkce "Zpet", je tohle '+
                                                  'jedina moznost, jak vratit nejakou chybu.',ano);
                              end;
 case tlacitka[tsoubor].klik of 1:begin
                                  tlacitka[tsoubor].stisk;
                                  kvyp; setwritemode(0);
                                  save;
                                  jmenos:=vloztextokno('Sesit:',5,jmenos,ano);
                                  nactihlavicku;
                                  load;
                                  setwritemode(1);
                                  nastavkurzor(6);
                                  kzap;
                                  end;
                                2:infokno(xmys,ymys,'Umoznuje prejit do jineho sesitu.',ano);
                                end;
 case tlacitka[telipsa].klik of 1:begin
                                  tlacitka[telipsa].stisk;
                                  znovuelipsa:
                                  nastavkurzor(2);
                                  resetuj; cekej;
                                  px:=xmys; py:=ymys;
                                  resetuj;
                                  kvyp;
                                  setwritemode(1);
                                  setcolor(barvacary xor barvapozadi);
                                   repeat
                                   px2:=xmys-px;
                                   py2:=ymys-py;
                                   rectangle(px-px2,py-py2,px+px2,py+py2);
                                   cekejnacokoli;
                                   rectangle(px-px2,py-py2,px+px2,py+py2);
                                   until stavtlacitek>0;
                                  pcotoje:=pelipsa;
                                  pbarva:=barvacary;
                                  pret:='';
                                  px2:=abs(px2);
                                  py2:=abs(py2);
                                  inc(px2,px); inc(py2,py);
                                  ulozprvek;
                                  kresliprvek;
                                  poslednifunkce:=relipsa;
                                  nastavkurzor(6); kzap; resetuj;
                                  end;
                                2:infokno(xmys,ymys,'Nakresli elipsu. Prvnim klikem zadejte stred, druhym rozmery.',ano);
                                end;
 case tlacitka[tobdelnik].klik of 1:begin
                                    tlacitka[tobdelnik].stisk;
                                    znovuobdelnik:
                                    nastavkurzor(2);
                                    resetuj; cekej;
                                    px:=xmys; py:=ymys;
                                    resetuj;
                                    kvyp; setwritemode(1);
                                    setcolor(barvacary xor barvapozadi);
                                     repeat
                                     px2:=xmys-px;
                                     py2:=ymys-py;
                                     rectangle(px,py,px+px2,py+py2);
                                     cekejnacokoli;
                                     rectangle(px,py,px+px2,py+py2);
                                     until stavtlacitek>0;
                                    pcotoje:=pobdelnik;
                                    pbarva:=barvacary;
                                    pret:='';
                                    inc(px2,px); inc(py2,py);
                                    ulozprvek;
                                    kresliprvek;
                                    poslednifunkce:=robdelnik;
                                    nastavkurzor(6); kzap; resetuj;
                                    end;
                                  2:infokno(xmys,ymys,'Kresleni obdelniku. Kliknutim zadejte dva protilehle vrcholy.',ano);
                                  end;
 case tlacitka[tkresleniodruky].klik of 1:begin
                                          tlacitka[tkresleniodruky].stisk;
                                          kresleniodruky:=tlacitka[tkresleniodruky].stisknuto;
                                          end;
                                 2:infokno(xmys,ymys,'Prepina rezim kresleni car - bud rovne nebo od ruky. Viz napovedu.',ano);
                                        end;
 case tlacitka[tbarvacary].klik of 1:begin
                                     tlacitka[tbarvacary].stisk;
                                     kvyp;setwritemode(0);
                                     barvacary:=vyberbarvuokno(barvacary);
                                     kreslipanel;
                                     nastavkurzor(6);
                                     setwritemode(1);kzap;
                                     end;
                                 2:infokno(xmys,ymys,'Nastaveni barvy, kterou se budou kreslit cary, elipsy a obdelniky.',ano);
                                   end;
 case tlacitka[tbarvapozadi].klik of 1:begin
                                       tlacitka[tbarvapozadi].stisk;
                                       kvyp;setwritemode(0);
                                       barvapozadi:=vyberbarvuokno(barvapozadi);
                                       prekresli;
                                       kreslipanel;
                                       nastavkurzor(6);
                                       kzap;
                                       end;
                                     2:infokno(xmys,ymys,'Nastaveni barvy papiru.',ano);
                                     end;
 case tlacitka[tbarvatextu].klik of 1:begin
                                      tlacitka[tbarvatextu].stisk;
                                      kvyp;
                                      setwritemode(0);
                                      barvatextu:=vyberbarvuokno(barvatextu);
                                      kreslipanel;
                                      nastavkurzor(6);
                                      kzap;
                                      end;
                                    2:infokno(xmys,ymys,'Nastaveni barvy, kterou se bude psat text.',ano);
                                    end;
 case tlacitka[tfont].klik of 1:begin
                                tlacitka[tfont].stisk;
                                kvyp;setwritemode(0);
                                nastavkurzor(0);
                                pfont:=vyberfontokno;{++++++++++++}
                                settextstyle(pfont,0,pvelikostpisma);
                                rozmerykurzoru(textwidth('A'),textheight256('A'));
                                nastavkurzor(6);
                                setwritemode(1);
                                kzap;
                                end;
                              2:infokno(xmys,ymys,'Nastaveni fontu.',ano);
                              end;
 case tlacitka[tvelikostpisma].klik of 1:begin
                                         tlacitka[tvelikostpisma].stisk;
                                         kvyp;setwritemode(0);
                                         nastavkurzor(0);
                                         pvelikostpisma:=vlozcislookno('Velikost pisma',2,pvelikostpisma);{++++++++}
                                         settextstyle(pfont,0,pvelikostpisma);
                                         rozmerykurzoru(textwidth('A'),textheight256('A'));
                                         nastavkurzor(6);
                                         setwritemode(1);
                                         kzap;
                                         end;
                                       2:infokno(xmys,ymys,'Nastaveni velikosti pisma, vychozi velikost je 1.',ano);
                                       end;
 case tlacitka[tuss].klik of 1:begin{+++++++++++}
                               tlacitka[tuss].stisk;
                               kvyp;
                               setwritemode(0);
                               setcolor(barvapozadi xor 4);
                               if ussy>paneldy then line(0,ussy,getmaxx,ussy);
                               line(ussx,paneldy+1,ussx,getmaxy);
                               nastavkurzor(3); kzap;
                               infokno(0,getmaxy,'Kliknutim zadej novy pocatek souradnic.',ne);
                               ussx:=xmys; ussy:=ymys;
                               kvyp; nastavkurzor(6);
                               prekresli;
                               kreslipanel;
                               resetuj;
                               end;
                             2:infokno(xmys,ymys,'Nastaveni polohy pocatku souradnic.',ano);
                             end;
 case tlacitka[tnastaveni].klik of 1:begin
                                     tlacitka[tnastaveni].stisk;
                                     setup;
                                     end;
                                   2:infokno(xmys,ymys,'Nastaveni programu.',ano);
                                   end;
 case tlacitka[tnapoveda].klik of 1:begin
                                    tlacitka[tnapoveda].stisk;
                                    help;
                                    end;
                                  2:infokno(xmys,ymys,{'Napoveda k napovede? Takove veci dela jen Microsoft.'}
                                                    'help - still under construction',ano);
                                  end;
 case konect.klik of 1:begin
                       konect.stisk;
                       konecb:=ano;
                       end;
                     2:infokno(xmys,ymys,'Konec programu, aktualni stranka se automaticky ulozi.',ano);
                     end;
 if lmys and (ymys>paneldy) then
              begin
              pcotoje:=pcara;
              pbarva:=barvacary;
              if kresleniodruky then begin
                                      repeat
                                      px:=xmys; py:=ymys; px2:=xmys; py2:=ymys;
                                      setcolor(barvacary);
                                       repeat
                                       line(px,py,px2,py2);
                                       speccekejnacokoli;
                                       line(px,py,px2,py2);
                                       px2:=xmys; py2:=ymys;
                                       until (abs(px2-px)>=delkacarky)or(abs(py2-py)>=delkacarky)or not lmys;
                                      ulozprvek;
                                      kvyp; kresliprvek; kzap;
                                      until not lmys;
                                     end
                                else begin
                                      repeat
                                      px:=xmys; py:=ymys;
                                      resetuj;
                                      setcolor(barvacary);
                                      px2:=xmys; py2:=ymys;
                                       repeat
                                       line(px,py,px2,py2);
                                       cekejnacokoli;
                                       line(px,py,px2,py2);
                                       px2:=xmys; py2:=ymys;
                                       konecb:=(keypressed and(readkey=#27));
                                       until (stavtlacitek>0)or konecb;
                                      if not konecb then begin
                                                         ulozprvek;
                                                         kvyp; kresliprvek; kzap;
                                                         end;
                                      until pmys or konecb;
                                     konecb:=ne;
                                     resetuj;
                                     end;
              end{if lmys}
 else if pmys then begin
                   case poslednifunkce of robdelnik:goto znovuobdelnik;{+++++jinak!}
                                          relipsa:goto znovuelipsa;
                                          {++++++++++++++++++}
                                          end;
                   end;
 if keypressed then begin
                    o:=readkey;
                    case o of 'A'..'Z','a'..'z','0'..'9','!','~','@','#','$','%','^','&','*','(',')','-','_','=','+',
                              '[',']','{','}','\','|',';',':','''','"',',','<','.','>','/','?',
                              '','','','','','','','','','','','','','','',
                              '','','','','','','','','','','','','','','',' '
                              :begin {psani}
                               if pisese then if nakonci then begin
                                                              pret:=pret+o;{pripsani znaku}
                                                              inc(index);{o znak dal}
                                                              setcolor(barvatextu);
                                                              kvyp;
                                                              outtextxy(xmys,ymys,o);{vypis}
                                                              presunmys(xmys+textwidth(o),ymys);{kurzor}
                                                              kzap;
                                                              end
                                                         else begin{if not nakonci}
                                                              insert(o,pret,succ(index));{vlozeni znaku}
                                                              inc(index);{o znak dal}
                                                              kvyp;
                                                              setfillstyle(1,barvapozadi);{vymazani textu vpravo}
                                                              bar(xmys,ymys,px+textwidth(pret),py+textheight256(pret));
                                                              setcolor(barvatextu);{vypsani textu}
                                                              outtextxy(px,py,pret);
                                                              presunmys(xmys+textwidth(o),ymys);{kurzor}
                                                              kzap;
                                                              end
                                         else begin{if not pisese}
                                              px:=xmys; py:=ymys;{souradnice}
                                              minx:=xmys; miny:=ymys;{pro odradkovani}
                                              pret:=o;
                                              index:=1;
                                              pcotoje:=ptext;
                                              pbarva:=barvatextu;
                                              setcolor(barvatextu);
                                              kvyp;
                                              zapnipsani;
                                              outtextxy(px,py,o);
                                              presunmys(xmys+textwidth(o),ymys);
                                              kzap;
                                              end;
                               end;{psani}
                              #13:begin {novy radek}
                                  if pisese then begin
                                                 {normaltext;++++aktivovat a vyzkouset}
                                                 ulozprvek;
                                                 vypnipsani;
                                                 end;
                                  presunmys(minx,miny+textheight256('A')+meziradky);
                                  miny:=ymys;
                                  end;
                              #8:begin
                                 if pisese then begin
                                                kvyp;
                                                if nakonci then begin{pisese and nakonci}
                                                                if index<=1 then begin{smazani prvniho a jedineho pismena}
                                                                                 presunmys(xmys-textwidth(pret[index]),ymys);
                                                                                 setcolor(barvapozadi);
                                                                                 outtextxy(xmys,ymys,pret[index]);
                                                                                 index:=0;
                                                                                 pret:='';
                                                                                 vypnipsani;
                                                                                 end
                                                                            else begin{smazani posledniho pismena}
                                                                                 presunmys(xmys-textwidth(pret[index]),ymys);
                                                                                 setcolor(barvapozadi);
                                                                                 outtextxy(xmys,ymys,pret[index]);
                                                                                 dec(index);
                                                                                 dec(byte(pret[0]));
                                                                                 end;
                                                                end{pisese and nakonci}
                                                           else begin{pisese and not nakonci}
                                                                if index=0 then begin{BSp pred prvnim pismenem}
                                                                                ulozprvek;
                                                                                vypnipsani;
                                                                                dec(minx,sirkatabulatoru*textwidth('A'));
                                                                                presunmys(minx,ymys);
                                                                                end
                                                                 else if index=1 then begin{smazani prvniho pismena}
                                                                                   presunmys(xmys-textwidth(pret[index]),ymys);
                                                                                      setcolor(barvapozadi);
                                                                                      outtextxy(px,py,pret);
                                                                                      delete(pret,index,1);
                                                                                      index:=0;
                                                                                      end
                                                                  else begin{nekde uprostred}
                                                                       presunmys(xmys-textwidth(pret[index]),ymys);
                                                                       setcolor(barvapozadi);
                                                                   outtextxy(xmys,ymys,copy(pret,index,byte(pret[0])-index+1));
                                                                       delete(pret,index,1);
                                                                       dec(index);
                                                                       setcolor(barvatextu);
                                                                       outtextxy(px,py,pret);{nechce se mi to pocitat+++++++++}
                                                                       end;
                                                                end;{pisese and not nakonci}
                                                kzap;
                                                end{if pisese}
                                           else begin{not pisese}
                                                dec(minx,sirkatabulatoru*textwidth('A'));
                                                presunmys(minx,ymys);
                                                end;
                                 end;{backspace}
                              #9:begin
                                 if pisese then begin
                                                ulozprvek;
                                                pisese:=ne;
                                                barvakurzoru(15);
                                                end;
                                  repeat
                                  inc(minx,sirkatabulatoru*textwidth('A'));
                                  until minx>xmys;
                                 presunmys(minx,ymys);
                                 end;
                              #27:begin
                                  if pisese then begin ulozprvek; vypnipsani; end;
                                  end;
                              ^z:zjistujsouradnice;{ctrl+z}
                              #0:case ord(readkey) of F2:begin
                                                         if pisese then begin
                                                                        ulozprvek;
                                                                        vypnipsani;
                                                                        end;
                                                         save;
                                                         end;
                                                      F3:if potvrzenipriload then begin
                                                                                 if anoneokno('Pokud jste v souboru provedli|'+
                                                                                               'nejake zmeny, prijdete o ne.|'+
                                                                                         'Opravdu chcete soubor znovu nacist?')
                                                                                               then load;
                                                                                  end
                                                                             else load;
                                                      lsipka:begin
                                                             if pisese then begin
                                                                            if index=0 then begin
                                                                                            ulozprvek;
                                                                                            vypnipsani;
                                                                                             repeat
                                                                                             prvekp:=prvekp^.predchozi;
                                                                                     until(prvekp^.cotoje=ptext)or(prvekp=nil);
                                                                                            if prvekp=nil then begin
                                                                                                               prvekp:=prvni;
                                                                                 while(prvekp^.cotoje<>ptext)and(prvekp<>nil)do
                                                                                                         prvekp:=prvekp^.dalsi;
                                                                                                               end;
                                                                                            with prvekp^ do begin
                                                                                                            pret:=ret;
                                                                                                            px:=x; py:=y;
                                                                                                            pbarva:=barva;
                                                                                                            pcotoje:=ptext;
                                                                                                            pfont:=font;
                                                                                                 pvelikostpisma:=velikostpisma;
                                                                                                            end;
                                                                                          settextstyle(pfont,0,pvelikostpisma);
                                                                                            seridkurzor;
                                                                                            setcolor(pbarva);
                                                                                            kreslibarvy;
                                                                                            index:=byte(pret[0]);
                                                                                            presunmys(px+textwidth(pret),py);
                                                                                            zapnipsani;
                                                                                            end
                                                                                       else begin{if pisese and index>0}
                                                                                   presunmys(xmys-textwidth(pret[index]),ymys);
                                                                                            dec(index);
                                                                                            end;
                                                                            end
                                                                       else begin{not pisese}
                                                                            presunmys(xmys-textwidth('A'),ymys);
                                                                            end;
                                                             end;{lsipka}
                                                      psipka:begin
                                                             if pisese then begin
                                                                            if nakonci then begin
                                                                                            if alt=0 then begin
                                                                                                          ulozprvek;
                                                                                                          vypnipsani;
                                                                                                          index:=0;
                                                                                           presunmys(xmys+textwidth('A'),ymys);
                                                                                                          end
                                                                                                     else normaltext;
                                                                                            end
                                                                                       else begin{pisese and not nakonci}
                                                                                            inc(index);
                                                                                   presunmys(xmys+textwidth(pret[index]),ymys);
                                                                                            end
                                                                            end
                                                                       else presunmys(xmys+textwidth('A'),ymys);
                                                             end;{psipka}
                                                      hsipka:begin
                                                             if pisese then begin
                                                                            if nakonci then hindex;
                                                                            end
                                                                       else presunmys(xmys,ymys-textheight256('A')-meziradky);
                                                             end;{hsipka}
                                                      dsipka:begin
                                                             if pisese then begin
                                                                            if nakonci then dindex;
                                                                            end
                                                                       else presunmys(xmys,ymys+textheight256('A')+meziradky);
                                                             end;
                                                      altF4:konecb:=ano;
                                                      F5:begin {prekresleni}
                                                         if pisese then begin
                                                                        ulozprvek;
                                                                        vypnipsani;
                                                                        end;
                                                         prekresli;
                                                         end;
                                                      F6:begin
                                                         tlacitka[tkresleniodruky].stisk;
                                                         kresleniodruky:=not kresleniodruky;
                                                         end;
                                                      F9:begin
                                                         setwritemode(0);
                                                      infokno(getmaxx shr 1, getmaxy shr 1, 'Pamet: '+nastr(maxavail)+'B',ano);
                                                         setwritemode(1);
                                                         end;
                                                      F7:begin
                                                         barvakurzoru(15);
                                                         ussx:=vlozcislookno('X',5,ussx);
                                                         ussy:=vlozcislookno('Y',5,ussy);
                                                         setwritemode(1); nastavkurzor(6);
                                                         end;
                                                      F8:begin
                                                         {kvyp;
                                                         pvelikostpisma:=vlozcislookno('velikost pisma',2,pvelikostpisma);
                                                         pfont:=vyberfontokno;
                                                         settextstyle(pfont,0,pvelikostpisma);
                                                         setwritemode(1); nastavkurzor(6);
                                                         seridkurzor;
                                                         kzap;}
                                                         chdir(adresarprogramu);
                                                         end;
                                                      endk:begin
                                                           if pisese then begin
                                                                          index:=byte(pret[0]);
                                                                          presunmys(px+textwidth(pret),ymys);
                                                                          end
                                                                     else begin
                                                                          prvekp:=posledni;
                                                                          while(prvekp<>nil)and(prvekp^.cotoje<>ptext)do
                                                                           prvekp:=prvekp^.predchozi;
                                                                          if prvekp=nil then prvekp:=posledni
                                                                                        else begin{nacteni prvku}
                                                                                             with prvekp^ do
                                                                                              begin
                                                                                              pcotoje:=ptext;
                                                                                              pret:=ret;
                                                                                              px:=x+ussx; py:=y+ussy;
                                                                                              minx:=px; miny:=py;
                                                                                              pbarva:=barva;
                                                                                              barvatextu:=barva;
                                                                                              setcolor(barva);
                                                                                              presunmys(px+textwidth(ret),py);
                                                                                              end;{with}
                                                                                             vymazprvek;
                                                                                             zapnipsani;
                                                                                             index:=byte(pret[0]);
                                                                                             end;
                                                                          end;
                                                           end;{endk}
                                                      end;{case ord(readkey)}
                              end;{case readkey}
                    end;{if keypressed}
 UNTIL konecb;
if autosaveb then save;
savesetup;
vyhodseznam;
konecgrafiky;
END.